package nl.voidcorp.discord.commands.music

import nl.voidcorp.discord.command.*
import nl.voidcorp.discord.music.PlayerManager
import org.springframework.stereotype.Service

@Service
class PlaylistCommand(val playerManager: PlayerManager) :
    Command("playlist", location = CommandSource.GUILD, group = CommandGroup.MUSIC) {
    override fun handle(event: CommandMessage): CommandResult {
        val player = playerManager.getGuildPlayer(event.guild!!)
        val list = player.totalList.take(10)
            .mapIndexed { index, audioTrack -> "${index + 1} - ${audioTrack.info.title}" }
            .joinToString("\n")
        if (list.isNotBlank())
            event.reply(list)
        else
            event.reply("The playlist is still empty...")
        return CommandResult.SUCCESS
    }
}