package nl.voidcorp.discord.events

import net.dv8tion.jda.api.entities.Activity
import net.dv8tion.jda.api.events.ReadyEvent
import net.dv8tion.jda.api.events.ReconnectedEvent
import net.dv8tion.jda.api.hooks.ListenerAdapter
import nl.voidcorp.discord.logger
import nl.voidcorp.discord.storage.ConfigStore
import org.springframework.stereotype.Service

@Service
class OttoListener(val configStore: ConfigStore) : ListenerAdapter() {
    override fun onReady(event: ReadyEvent) {
        logger.info("Found ${event.guildTotalCount} different guilds!")
    }

    override fun onReconnect(event: ReconnectedEvent) {
        val id = event.jda.shardInfo!!.shardId
        val reconn = event.responseNumber
        val version = configStore.version
        event.jda.presence.activity = Activity.playing("v$version ($id~$reconn)")

    }
}