package nl.voidcorp.discord.music

import com.sedmelluq.discord.lavaplayer.track.AudioTrack
import net.dv8tion.jda.api.entities.Guild
import net.dv8tion.jda.api.entities.TextChannel
import org.apache.logging.log4j.LogManager

abstract class MusicAnnouncer(open val channel: TextChannel?, private val guild: Guild) {

    private val logger = LogManager.getLogger("Music - ${guild.name}")

    fun close() {
        guild.audioManager.closeAudioConnection()
    }

    open fun sendPlayTrack(track: AudioTrack) {
        logger.info("Playing ${track.info.title} (${track.identifier})")
    }

    open fun sendQueueTrack(track: AudioTrack) {
        logger.info("Queued ${track.info.title}")
    }
}